@echo off

::  https://windowsaddict.ml/office-license-is-not-genuine

::  Thanks to @dialmak for the solution
::  http://forum.ru-board.com/topic.cgi?forum=35&topic=81283&start=6080#19

::  Script concept:-

::  On Windows 7, since the support is ended for it, Office C2R only receives security updates, and updates are locked at version 2002 (build 12527.#####). (Tricks to get latest version on 7 are not working properly.)
::  And banner started appearing at Version 2101, Build 13628.20380, with the current update channel in February 2021
::  Hence Offices on Windows 7 are not affected by the banner and this script doesn't apply the solution

::  Solution requires to set KMS server (any name/IP except blacklisted public KMS server name (not IP)) for global (and also for it's 32bit registry key on 64bit Windows) and for specific Office SKUID
::  Banner affected Office versions are Office Volume C2R 2016/2019/2021, script applies the solution only if they exist


reg query HKU\S-1-5-19 1>nul 2>nul || (
echo Right click on this file and select 'Run as administrator'.
goto :end
)

set app=
setlocal EnableDelayedExpansion
for /f "tokens=2 delims==" %%G in ('"wmic path SoftwareLicensingProduct where (ApplicationID='0ff1ce15-a989-479d-af46-f275c6370663' and Description like '%%KMSCLIENT%%' and not Description like '%%Office 15%%' and PartialProductKey is not NULL) get ID /VALUE" 2^>nul') do (if defined app (call set "app=!app! %%G") else (call set "app=%%G"))

if not defined app (
echo Could not detect Volume version of Office C2R 2016/2019/2021 on Windows 8 and later.
goto :end
)

sc query ClickToRunSvc 1>nul 2>nul
if %errorlevel%==1060 (
echo Could not detect Office C2R version.
goto :end
)

for %%# in (%app%) do (
reg add "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\SoftwareProtectionPlatform\0ff1ce15-a989-479d-af46-f275c6370663\%%#" /f /v KeyManagementServiceName /t REG_SZ /d "0.0.0.0"
)

reg add "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\SoftwareProtectionPlatform" /f /v KeyManagementServiceName /t REG_SZ /d "0.0.0.0"
reg add "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\SoftwareProtectionPlatform" /f /v KeyManagementServiceName /t REG_SZ /d "0.0.0.0" /reg:32

:end
echo:
echo Press any key to exit...
pause >nul